package quimufu.colourful_portals;

import org.ladysnake.cca.api.v3.component.ComponentKey;
import org.ladysnake.cca.api.v3.component.ComponentRegistry;
import org.ladysnake.cca.api.v3.level.LevelComponentFactoryRegistry;
import org.ladysnake.cca.api.v3.level.LevelComponentInitializer;
import net.minecraft.util.Identifier;
import quimufu.colourful_portals.portal.PortalListComponent;

public class Components implements LevelComponentInitializer {
    public static final ComponentKey<PortalListComponent> PORTAL_LIST =
            ComponentRegistry.getOrCreate(Identifier.of(ColourfulPortalsMod.MOD_ID, "portal_list"), PortalListComponent.class);
    public static final ComponentKey<PortalListComponent> PORTAL_CANDIDATE_LIST =
            ComponentRegistry.getOrCreate(Identifier.of(ColourfulPortalsMod.MOD_ID, "portal_candidate_list"), PortalListComponent.class);

    @Override
    public void registerLevelComponentFactories(LevelComponentFactoryRegistry registry) {
        registry.register(PORTAL_LIST, worldProperties1 -> new PortalListComponent());
        registry.register(PORTAL_CANDIDATE_LIST, worldProperties -> new PortalListComponent());

    }
}
